/**************************************************************
  (C) 1997 by Achim Kaiser

  You may distribute under the terms of the GNU General Public
  License as specified in the COPYING file.
**************************************************************/

#include <X11/Xlib.h>
#include <X11/Xutil.h>
#include <malloc.h>
#include "global.h"

unsigned long GetBestColor(int r,int g,int b)
{    
  Colormap cmap;
  XColor backcolor,*pixcolors;
  long difference,localdifference;
  int i;
  unsigned long bg=0;
  backcolor.red=r;
  backcolor.green=g;
  backcolor.blue=b;
  cmap=XDefaultColormap(GetDisplay(),XDefaultScreen(GetDisplay()));
  if (XAllocColor(GetDisplay(),cmap,&backcolor)!=0)
    bg=backcolor.pixel;
  else {
    pixcolors=malloc((1<<XDefaultDepth(GetDisplay(),XDefaultScreen(GetDisplay())))*sizeof(XColor));
    difference=65535;
    for (i=0;i<(1<<XDefaultDepth(GetDisplay(),XDefaultScreen(GetDisplay())));i++) 
      pixcolors[i].pixel=(unsigned long)i;
    XQueryColors(GetDisplay(),cmap,pixcolors,(1<<XDefaultDepth(GetDisplay(),
							       XDefaultScreen(GetDisplay()))));
    for (i=0;i<(1<<XDefaultDepth(GetDisplay(),XDefaultScreen(GetDisplay())));i++)
      if ((localdifference=(long)((labs((long)pixcolors[i].red-(long)backcolor.red)+
				   labs((long)pixcolors[i].green-(long)backcolor.green)+
				   labs((long)pixcolors[i].blue-(long)backcolor.blue))/3))
	  <difference) {
	difference=localdifference;
	bg=(unsigned long)i;
      }
    free(pixcolors);
  }
  return bg;
}

unsigned long* GetXVColors()
{
  unsigned long* xvp;
  Colormap cmap;
  XColor pix;
  XColor *pixcolors;
  int a,b;
  long difference,localdifference;
  cmap=XDefaultColormap(GetDisplay(),0);
  xvp=malloc(256*sizeof(unsigned long));
  for (a=0;a<256;a++) {
    difference=65535;
    pix.red=9362*(224&a)/32;
    pix.green=9362*(28&a)/4;
    pix.blue=21845*(3&a);
    if (XAllocColor(GetDisplay(),cmap,&pix)!=0)
      xvp[a]=pix.pixel;
    else {
      pixcolors=malloc((1<<XDefaultDepth(GetDisplay(),0))*sizeof(XColor));
      for (b=0;b<(1<<XDefaultDepth(GetDisplay(),0));b++) 
	pixcolors[b].pixel=(unsigned long)b;
      XQueryColors(GetDisplay(),cmap,pixcolors,(1<<XDefaultDepth(GetDisplay(),0)));
      for (b=0;b<(1<<XDefaultDepth(GetDisplay(),0));b++)
	if ((localdifference=(long)((labs((long)pixcolors[b].red-(long)pix.red)+
				     labs((long)pixcolors[b].green-(long)pix.green)+
				     labs((long)pixcolors[b].blue-(long)pix.blue))/3))
	    <difference) {
	  difference=localdifference;
	  xvp[a]=(unsigned long)b;
	}
      free(pixcolors);
    }
  }
  return xvp;
}
